{

   The P-NAV Propeller Project
    R/C Autopilot with OSD and Ground Station Data via XB 
    earl@uphi.net
    04/13/2009
    Contibutions by:
    Paul Huber
    and others.....
                                                      
}
CON
  
' NAME        PIN#  / VALUE
' ----------- ------- ----------  

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000

' GPS Assignments                                        
  GPSin     = 08                                        ' fm GPS NEMA data
  GPSout    = 09                                        ' to GPS (to set baud, SIRF or NMEA etc. May be needed for your GPS)
  Nunchuck_Addr = $A4


' Video Output Assignments                              
  TVBase    = 12                                        ' TV  base pin         

' Rx Input Assignments                              
  RxAler    = 24 'pin 4 on rx  aleron
  RxElev    = 25 'pin 5 on rx  elevator
  RxRudder  = 26 'pin 6 on rx  throtle                                                              
  RxThrot   = 27 'pin 7 on rx  rudder
  RxGear    = 11 'pin 11 on gear switch
  
' Servos Output pins
  SrvAle    = 16                                        
  SrvRudder = 17                                       
  SrvElev   = 18                                       
  SrvThrot  = 19
                               
  PING_Pin  = 10     'for close ground mesurement  
                     
    cEnable = 5      'clock,data,enable pins compass
    cClock  = 6
    cData   = 7 
 
                                                                                                                
VAR

  long  stackRC[100]                                    ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long  stackOSD[100]                                   ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long  rx[ 8]                                          ' FROM r/c receiver from ~0450 to ~1100   
  long sign,ang,ptr,prop_lat,prop_rad                   ' to save stack space
  
   byte OSD                                              ' use to check if the TV background has been painted once.

   word rx5
   word rx6
   word rx7
   word rx8
   word accel_x
   word accel_y
   word accel_z

   long _220uS
   byte i2cSCL, i2cSDA

   long time
   long rangeIN
   long rangeMM
   long rangeCM
   long degree

   byte temp

     word tempF,tempc,BaroP,tempfraw,temp1,temp2
  word UT,UP,p,B3,B4,B6,Y1,f1,f2,f3,f4,ac1,ac2,ac3,ac4,ac5,ac6,b1,b2
  word x1,x1a,x2,y2,x3,y3,x4,y4,b5,t,mmHg,mmIn,mmInF,mmInW
  word altitudeM,altitudeF

   
OBJ                                                    
  clock      :  "Clock"                                 ' overall timers 
  tv         :  "tv_text"                               ' TV video output driver
  BS2        :  "BS2_Functions"                         ' BS2 Functions for I/O
  gps        :  "GPS_IO_mini_PNAV"                      ' Services GPS input and etrex extension           
  ser        :  "FullDuplexSerial_mini"
  Nun        :  "i2c_Accl_Data_Read"                                 'N-chuck accl data subs
  i2cObject1 :  "ECi2c"                                 'i2c comm stuff
  ping       :  "ping"
  HM55B      :  "Sensor.HM55B.Compass"
  Baro       :  "EC_i2c_readbaro"
  XB         :  "XBee_Object"

PUB start

''Initialize all necessary routines into their cogs as appropriate
 
Clock.Init(_XINFREQ)                   ' my module data                ' set up clock for accurate 10/second
Clock.SetClock(_CLKMODE)                                ' video update rate
Clock.MarkSync

cognew(RC_io,@stackRC)                                  ' start R/C in/out on its own cog
cognew(OSD_INI_Screen,@stackOSD)

tv.start(TVBase)                                        ' start TV display
BS2.Start(30,31)
gps.start(GPSin,GPSout)                                 ' start GPS ingest (gets its own cog)
Nun.init(28,29)                                         ' scl and sda on pin 28 and pin 29 for I2C
HM55B.start(cEnable,cClock,cData)                       ' start compass module
Baro.init(28,29)                                        ' scl and sda on pin 28 and pin 29

  DIRA[20]~~                          'make servo pin output
  DIRA[21]~~                          'make servo pin output
  DIRA[22]~~                          'make servo pin output
  DIRA[23]~~                          'make servo pin output
  
degree := 0

OSD_INI_Screen                        ' Print AutoPilot data Layout Screen
OSD_INI_Screen                        ' Havent figgured out why I need to do this twice ???                
'XB.AT_init                            'inish the xbee module
ControlLoop                           ' overall control loop

'***************************************************************************************
'                               Main program
'***************************************************************************************
                        
PUB ControlLoop                   ' primary loop
repeat

  GetAlt                          'Get the Barometric altitude
  
  Accl_get                        ' Get Accl xyz inputs
 
  degree := HM55B.degrees         ' Get compass heading from HM55B
      
  rangeIN := ping.Inches(PING_Pin)' Get Range In Inches
 
  OSD_GPS1                        ' Print all data on TV
   
    waitcnt(2500000 + cnt)            ' loop cycle time (~1/4 sec)
    
    tv.str(string($A,37,$B,11))       'testing to flash arrow ********************                         
    tv.str(string(4))                 'testing to flash arrow ********************
    waitcnt(2500000 + cnt)            'testing to flash arrow ******************** 
     tv.str(string($A,37,$B,11))      'testing to flash arrow ********************                          
    tv.str(string(5))                 'testing to flash arrow ********************
  
 
       
'At this point we have all HM55B Compass,GPS,accl x-y-z,RX,Distance to Ground (in Inches)
' and output servo position data !
'We can use the data for stabilization ,return home,send data to Gnd via XB or goto via gps !
'*********************************************************************************************
                                            
                          'Do everything over and over !

Pub OSD_INI_Screen


    tv.out($00)
  
'                  0         1         2         3        
'                  0123456789012345678901234567890123456789

    tv.str(string("___________ AutoPilot Data____________ ",13))    'setup the tv screen graphics layout
    tv.str(string("Lock:  x      Compass      InHg        ",13))
    tv.str(string("Latitude:     _xxxx.xxxx  x            ",13))
    tv.str(string("Longitude:    xxxxx.xxxx  x            ",13))
    tv.str(string("Spd:          B-Alt       Head: xxx    ",13))
    tv.str(string("AutoPilot-    Gnd-Distance-Inch        ",13))
    tv.str(string("    Pitch                 Climb   Up   ",13))
    tv.str(string("    Roll                  Turning Left ",13))
    tv.str(string("    Yaw                   XB RSSI -72  ",13))
    tv.str(string("    Throt                 GND Link OK  ",13))
    tv.str(string("Acclerometer                           ",13))
    tv.str(string("Data sent to ground station via XBee   "))
'                  0         1         2         3        
'                  0123456789012345678901234567890123456789


Pub OSD_GPS1

'XB.start(6,7,0,19200)    'Get the XB module ready to run !!!
                              
   tv.str(string($A,7,$B,1))                                
    tv.str(gps.valid)
'    xb.tx(gps.valid)
 tv.str(string($A,22,$B,1))
 tv.str(string("    "))
 tv.str(string($A,22,$B,1))
 tv.dec(degree)                             ' Print Compass direction
'    xb.tx(degree)
 tv.str(string($A,26,$B,1))
  tv.str(string("InHg "))
 tv.dec(mmInW)                                     ' Print In of Hg
  tv.str(string("."))
 tv.dec(mmInF)                                     ' Print rest of Hg
'    xb.tx(mmIn)
  tv.str(string($A,15,$B,2))                                
    tv.str(gps.latitude)
'    xb.tx(gps.latitude)
   tv.str(string($A,26,$B,2))                                
    tv.str(gps.N_S)
'    xb.tx(gps.N_S)
  tv.str(string($A,14,$B,3))                                
    tv.str(gps.longitude)
'    xb.tx(gps.longitude)
   tv.str(string($A,26,$B,3))                                
    tv.str(gps.E_W)
'    xb.tx(gps.E_W)
   tv.str(string($A,7,$B,4))                                
    tv.str(gps.speed)
'    xb.tx(gps.speed)
   tv.str(string($A,20,$B,4))                                
 tv.str(string("     "))
  tv.str(string($A,20,$B,4))                                
    tv.dec(altitudeF)
       tv.str(string($A,32,$B,4))                                
    tv.str(gps.heading)
'    xb.tx(gps.heading)
 
  tv.str(string($A,10,$B,5))
    if (rx[7] > 600)
      tv.str(string("On "))
    else
     tv.str(string("Off"))
     
       
tv.str(string($A,32,$B,5))
 tv.str(string("        "))
tv.str(string($A,32,$B,5))
  tv.dec(rangeIN)                              ' Print Distance in Inches
        
    tv.str(string(13))
    tv.dec(rx[ 2])         'print  Throttle input                            
    tv.str(string(13))
    tv.dec(rx[ 1])         'print  Elevator input                           
    tv.str(string(13))
    tv.dec(rx[ 3])         'print  Aleiron input                         
    tv.str(string(13))
    tv.dec(rx[ 4])         'print  Rudder input    

      tv.str(string($A,14,$B,10)) 'set tv position to col 16 line 10     
      tv.dec(Nun.accelX)          'Print the decimal # for acceleration X axis
      tv.str(string(" X   "))   
     tv.dec(Nun.accelY)      
      tv.str(string(" Y   "))  
      tv.dec(Nun.accelZ)         
      tv.str(string(" Z   "))   
      tv.str(string($A,16,$B,11)) 'set tv position to col 16 line 11     
  
'XB.stop         'to save power ??
PUB RC_IO
repeat
                                        ' Get Radio Inputs
   rx[ 1] := BS2.PULSIN( RxAler,1)      ' aleron      
   rx[ 2] := BS2.PULSIN( RxElev,1)      ' elevator
   rx[ 3] := BS2.PULSIN( RxThrot,1)     ' throttle            
   rx[ 4] := BS2.PULSIN( RxRudder,1)    ' rudder          

    rx[ 7] := BS2.PULSIN( RxGear,1)     ' Gear input switch >550 = down(AP ON) 965 = up(AP OFF)
                
 '   BS2.PULSOUT(SrvAle,rx[ 2] )         'output to servos
 '   BS2.PULSOUT(SrvRudder,rx[ 1] )
    BS2.PULSOUT(SrvElev,Nun.accelY )     'this is for testing
    BS2.PULSOUT(SrvThrot, Nun.accelX )   'this is for testing
 '   BS2.PULSOUT(SrvThrot, rx[ 3])

PUB init

   Nun.init(28,29)                'scl and sda on pin 28 and pin 29
   
PUB Accl_get

Nun.readNunchuck        'Get the data via i2c bus

waitcnt(clkfreq /20+ cnt)

PUB readNunchuck | data[6]

   i2cObject1.writeLocation(Nunchuck_Addr, $0, $00)
   waitcnt(_220uS+cnt)
   i2cObject1.i2cStart
   i2cObject1.i2cWrite(Nunchuck_Addr)
   i2cObject1.i2cWrite(0)
   i2cObject1.i2cStop
   waitcnt(_220uS+cnt)
   i2cObject1.i2cStart
   i2cObject1.i2cWrite(Nunchuck_Addr|1)
   data[0] := (i2cObject1.i2cRead(0) ^ $17) + $17 
   data[1] := (i2cObject1.i2cRead(0) ^ $17) + $17 
   data[2] := (i2cObject1.i2cRead(0) ^ $17) + $17 'accl x value decoded
   data[3] := (i2cObject1.i2cRead(0) ^ $17) + $17 'accl y value decoded
   data[4] := (i2cObject1.i2cRead(0) ^ $17) + $17 'accl z value decoded
   data[5] := (i2cObject1.i2cRead(1) ^ $17) + $17 'lower bits of xyz data
   i2cObject1.i2cStop

   accel_x := data[2] << 2
   accel_y := data[3] << 2
   accel_z := data[4] << 2
   if (data[5] >> 2) & 1
      accel_x += 2                                                                               
   if (data[5] >> 3) & 1
      accel_x += 1                                                                               
   if (data[5] >> 4) & 1
      accel_y += 2                                                                               
   if (data[5] >> 5) & 1
      accel_y += 1                                                                               
   if (data[5] >> 6) & 1
      accel_z += 2                                                                               
   if (data[5] >> 7) & 1
      accel_z += 1


PUB accelX
   return accel_x

PUB accelY
   return accel_y

PUB accelZ
   return accel_z

PUB GetAlt

Baro.init(28,29)                                        ' scl and sda on pin 28 and pin 29

           Baro.start_adcPres                            ' start the adc then
           Baro.readBaro                                 ' read data via i2c bus
           UP :=  baro.baro_f6 * 256 + baro.baro_f7      'raw 16 bit pressure data put in UP

     
                                     'Calibration Data
       F1 := 39535 '((baro.baro_f8 * 256) + baro.baro_f9)        'F1 my module data 
       F2 := 40600 '((baro.baro_fa * 256) + baro.baro_fb)        'F2 my module data
       F3 := 3707  '((baro.baro_fc * 256) + baro.baro_fd)        'F3 my module data
       F4 := 26866 '((baro.baro_fe * 256) + baro.baro_ff)        'F4 my module data

       AC1 := 6767        ' calculated values from MY module (only needed to do once)
       AC2 := 634         ' see data sheet for SMD500 on how to calkulate !
       AC3 := 152
       AC4 := 3707
       AC5 := 7
       AC6 := 2290
      
       B1 := ((AC3 - 1984) * (-17268)) / 2048 - 8970
       B2 := ((AC2 - 457) * B1 / 8) / (AC3 - 1984)



      X1 := UT  - (AC6 + 1415) * 8                          'X1 =  4310
      X2 := X1 * X1 / 8192                                  'X2 =  2267
      Y2 := -4955 * X2 / 8192                               'Y2 = -1372
      X3 := X2 * X1 / 65536                                 'X3 =  149
      Y3 := 11611 * X3 / 4096                               'Y3 =  422
      X4 := X2 * X2 / 65536                                 'X4 =  78
      Y4 := -12166 * X4 / 16384                             'Y4 =  -58
      B5 := (AC5 + 4096)* (2 * X1 + Y2 + Y3 + Y4)/ 1024     'B5 =  4237
      T  := (B5 + 8) / 8                                    'T =   265  T is degrees C times 10

      TempC := T /100
      TempF := TempC *  (9/5) + 32   
         
           '      calculate coefficients B3 and B4
       B6 := B5 - 4000                                    ' B6 = 237
       X1 := (B2 * (B6 * B6 / 4096 )) / 1024              ' X1 = 0
       X2 := (AC2 - 457) * B6 / 512                       ' X2 = -103
       X3 := ((X1 + X2) + 2) / 2                          ' X3 = -26
       B3 := (AC1 - 2218) * 2 + X3                        ' B3 = 11704
       Y1 := (AC3 -1984) * B6 / 1024                      ' Y1 = -415
       Y2 := (B1 * (B6 * B6 / 4096 )) / 65535             ' Y2 = 1
       Y3 := ((Y1 + Y2) + 2) / 2                          ' Y3 = -103
       B4 := (AC4 + 8808) * (Y3 + 32768) / 16384          ' B4 = 26781
       
                                 'calculate true pressure
       p  := ((UP - B3) * 100000) / B4                    ' p   =  95732
       X1 := (p / 2^8 ) * (p / 256 )                      ' X1  = 139129
       X1a:= (X1 * 3038) / 65535                          ' X1a = 6449
       X2 := (- 7357 * p) / 65535                         ' X2  = -10747
       p  := p + (X1a + X2 + 3791) / 8                    ' p   = 95700
       mmIn := p / 25                                     ' mmIn Baro pressure * 100
       mmInW := mmIn/100                                  ' whole inches   
       mmInF := mmIn - mmInW*100                          ' fractions of inches
       mmHg := p / 100                                    ' mmHg Baro pressure ~600 in Mountainair,NM

       altitudeF:= (1000*mmhg*mmhg) / 42017 - (72346*mmhg) / 1000 + 41214
       altitudeM := 1000*altitudeF / 3280                 ' Actully 3.280839895
     
PUB GetTemp

Baro.init(28,29)                                        ' scl and sda on pin 28 and pin 29

           UP :=0
           Baro.start_adcTemp                           ' start the adc then
           Baro.readBaro                                ' read data via i2c bus
           UT :=  baro.baro_f6 * 256 + baro.baro_f7      'raw 16 bit pressure data in UP
        
                                'Calibration Data
       F1 := 39535 '((baro.baro_f8 * 256) + baro.baro_f9)        'F1 my module data 
       F2 := 40600 '((baro.baro_fa * 256) + baro.baro_fb)        'F2 my module data
       F3 := 3707  '((baro.baro_fc * 256) + baro.baro_fd)        'F3 my module data
       F4 := 26866 '((baro.baro_fe * 256) + baro.baro_ff)        'F4 my module data

       AC1 := 6767        ' calculated values from my module
       AC2 := 634
       AC3 := 152
       AC4 := 3707
       AC5 := 4
       AC6 := 2290
      
       B1 := ((AC3 - 1984) * (-17268)) / 2048 - 8970
       B2 := ((AC2 - 457) * B1 / 8) / (AC3 - 1984)



      X1 := UT  - (AC6 + 1415) * 8                          'X1 =  4310
      X2 := X1 * X1 / 8192                                  'X2 =  2267
      Y2 := -4955 * X2 / 8192                               'Y2 = -1372
      X3 := X2 * X1 / 65536                                 'X3 =  149
      Y3 := 11611 * X3 / 4096                               'Y3 =  422
      X4 := X2 * X2 / 65536                                 'X4 =  78
      Y4 := -12166 * X4 / 16384                             'Y4 =  -58
      B5 := (AC5 + 4096)* (2 * X1 + Y2 + Y3 + Y4)/ 1024     'B5 =  4237
      T  := (B5 + 8) / 8                                    'T =   265  T is degrees C times 10

      TempC := T / 100
      TempF := TempC *  (9 / 5) + 32   
     
        